Attribute VB_Name = "ovladac_LCD"
Option Explicit

Public Const SM_CXSCREEN = 0
Public Const SM_CYSCREEN = 1
Public Const HWND_TOPMOST = -1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const HWND_TOP = 0
Public Const HWND_NOTOPMOST = -2
Public Const HWND_BOTTOM = 1
Public Const GWL_EXSTYLE = (-20)
Public Const WS_EX_LAYERED = &H80000
Public Const LWA_ALPHA = &H2
Public Const LWA_COLORKEY = &H1
Public Const GWL_STYLE = (-16)
Public Const SW_SHOWNORMAL = 1
Public Const WM_SYSCOMMAND = &H112
Public Const CW_USEDEFAULT = &H80000000
Public Const SWP_NOACTIVATE = &H10
Public Const WS_POPUP = &H80000000
Public Const WS_EX_TOPMOST = &H8&


Dim Data As Long
Dim PortAdresa As Long
Dim w As Long
'Dim Aku As Integer
Dim cas As Single
Dim dwMilliseconds As Long
Dim credit As String * 4    'obsahuje 0 az 9999 hodnotu.
Dim cislo As String * 4     'obsahuje 0 az 255 hodnotu.
Dim Text1 As String * 40

Const cas1 As Integer = 1   'cekaci cas ve smicce pro testovani propravenosti LCD.
Const cas2 As Integer = 1  'ostatni cekani.

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (ByVal lpEventAttributes As Long, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function SetEvent Lib "kernel32" (ByVal hHandle As Long) As Long
Public Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadID As Long) As Long
Public Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long


Private Declare Function OpenPort Lib "knihovna.dll" (ByVal Port As String, ByVal Rozsah As Integer) As Integer 'Otevre a dotez na Port.
Private Declare Function UnLock_ Lib "knihovna.dll" () As Integer 'Otevre *.sys ovladac.
Private Declare Function Lock_ Lib "knihovna.dll" () As Integer 'Zavre *.sys ovladac.

Private Declare Function Dll_Register_Server Lib "knihovna.dll" (ByVal Reg As String) As Integer
Private Declare Function Dll_UnRegister_Server Lib "knihovna.dll" (ByVal Reg As String) As Integer

Private Declare Function Zapis Lib "knihovna.dll" (ByVal Port As Integer, ByVal Data As Byte) As Integer
Private Declare Function Zapis_Data Lib "knihovna.dll" (ByVal Data As Byte) As Integer
Private Declare Function Zapis_Status Lib "knihovna.dll" (ByVal Data As Byte) As Integer
Private Declare Function Zapis_Control Lib "knihovna.dll" (ByVal Data As Byte) As Integer

Private Declare Function Cteni Lib "knihovna.dll" (ByVal Port As Integer) As Integer
Private Declare Function Cteni_Data Lib "knihovna.dll" () As Integer
Private Declare Function Cteni_Status Lib "knihovna.dll" () As Integer
Private Declare Function Cteni_Control Lib "knihovna.dll" () As Integer

Private Declare Function chyba Lib "knihovna.dll" (ByVal text As String) As Integer
Private Declare Function Cekat Lib "knihovna.dll" (ByVal delka As Integer) As Integer

'Data is code    0
'Status is code  1
'Control is code 2

Private Declare Function GetTickCount& Lib "kernel32" ()
Private Sub Cekat1(cas As Single)
Dim cas1 As Single
Dim cas2 As Single

Let cas1 = GetTickCount() + cas
cas3:
Let cas2 = GetTickCount()
If cas2 <= cas1 Then Call Sleep(1): GoTo cas3

End Sub
Private Sub Main()
Dim MaxArgs As Integer
Dim ret As Long
Dim rnt As Integer
Dim Rozsah As Integer
Dim NazevPortu As String * 4

If App.PrevInstance Then
MsgBox "Aplikace u jednou b!", vbExclamation
End
End If

Let MaxArgs = 10
Let PortAdresa = &H378

Call UnLock_

Let Rozsah = 0
Let NazevPortu = "LPT1"
Let rnt = OpenPort(NazevPortu, Rozsah)
If rnt = -1 Then MsgBox "Nejde otevt LPT1 port!", vbExclamation: GoTo konec

Let Data = Cteni_Control() Or &H20       '%0010 0000
Zapis_Control (Data)                      'data cist

Dim C, CmdLine, CmdLnLen, InArg, i, NumArgs
ReDim Argarray(MaxArgs)
NumArgs = 0: InArg = False
CmdLine = Command()
CmdLnLen = Len(CmdLine)
For i = 1 To CmdLnLen
C = Mid(CmdLine, i, 1)
If (C <> " " And C <> vbTab) Then
If Not InArg Then
If NumArgs = MaxArgs Then Exit For
NumArgs = NumArgs + 1
InArg = True
End If
Argarray(NumArgs) = Argarray(NumArgs) & C
Else
InArg = False
End If
Next i
'prava velikosti pole podle potu argument.
ReDim Preserve Argarray(NumArgs)

If NumArgs = 0 Then
MsgBox "Nezadal jsi dn pkaz!" & (Chr(13)) & (Chr(13)) & "Proto ti te zobrazm npovdu a informace o tto aplikaci!", vbExclamation
Call Help1
Call About_
GoTo konec
End If

If Argarray(1) = "/init" Then
    Call init
    GoTo konec
ElseIf Argarray(1) = "/i" Then
    Call init
    GoTo konec
ElseIf Argarray(1) = "/cr" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let credit = Argarray(2)
    Call cr
    GoTo konec
ElseIf Argarray(1) = "/Power_0" Then
    Call Power_vypnout
    GoTo konec
ElseIf Argarray(1) = "/Power_1" Then
    Call Power_zapnout
    GoTo konec
ElseIf Argarray(1) = "/mezera" Then
    Call mezera
    GoTo konec
ElseIf Argarray(1) = "/m" Then
    Call mezera
    GoTo konec
ElseIf Argarray(1) = "/about" Then
    Call About_
    GoTo konec
ElseIf Argarray(1) = "/setup" Then
    Call setup1
    GoTo konec
ElseIf Argarray(1) = "/a" Then
    Call About_
    GoTo konec
ElseIf Argarray(1) = "/?" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "/help" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "/h" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "h" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "help" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "?" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "/pomoc" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "pomoc" Then
    Call Help1
    GoTo konec
ElseIf Argarray(1) = "/s" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let Text1 = Argarray(2)
    Call text
    GoTo konec
ElseIf Argarray(1) = "/cls" Then
    Call smazat
    GoTo konec
ElseIf Argarray(1) = "/c" Then
    Call smazat
    GoTo konec
ElseIf Argarray(1) = "/wc" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let cislo = Argarray(2)
    Call write_command
    GoTo konec
ElseIf Argarray(1) = "/ch" Then
    Call Cursor_home
    GoTo konec
ElseIf Argarray(1) = "/em" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let cislo = Argarray(2)
    Call Entry_mode
    GoTo konec
ElseIf Argarray(1) = "/dm" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let cislo = Argarray(2)
    Call Display_mode
    GoTo konec
ElseIf Argarray(1) = "/sgram" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let cislo = Argarray(2)
    Call Set_character_generator_RAM_address
    GoTo konec
ElseIf Argarray(1) = "/sdram" Then
    If NumArgs = 1 Then MsgBox "Nezadal jsi druh parametr!", vbExclamation: GoTo konec
    Let cislo = Argarray(2)
    Call Set_display_data_RAM_address
    GoTo konec
ElseIf Argarray(1) = "/gacc" Then
    Call Get_address_counter_contents
    'tato funkce vrati cislo v rozmezi 0 az 255
    GoTo konec
End If
MsgBox "Neznm, " & (Argarray(1)) & " pkaz." & (Chr(13)) & "Podvejte se do npovdy." & (Chr(13)) & "Npovdu obdrte po zadn znaku: ? .", vbExclamation
konec:
Call Lock_
End Sub

Private Sub Get_address_counter_contents()
'Returns address counter contents, used for both DDRAM and CGRAM.
'RAM address is returned in W
'NOT IMPLEMENT !!!!!! By HaCeSOFT


End Sub
Private Sub Set_display_data_RAM_address()
'Sets the Display-Data-RAM address. DDRAM data is read/written after this setting.
'Required entry mode must be set in W
'b0-6 : required DDRAM address
'b7: don 't care

Let w = Val(cislo)
If w > 255 Then MsgBox "slo nen v rozmez 0 a 255!" & (Chr(13)) & "Mete pout i sla v estnctkov soustav" & (Chr(13)) & "Nap.: 255 = &hff", vbExclamation: Call Lock_: End
Let w = w Or &H80              'Function set
Call LCDPUTCMD
End Sub
Private Sub Set_character_generator_RAM_address()
'Sets the Character-Generator-RAM address. CGRAM data is read/written after this setting.
'Required CGRAM address must be set in W
'b0-5 : required CGRAM address
'b6-7: don 't care

Let w = Val(cislo)
If w > 255 Then MsgBox "slo nen v rozmez 0 a 255!" & (Chr(13)) & "Mete pout i sla v estnctkov soustav" & (Chr(13)) & "Nap.: 255 = &hff", vbExclamation: Call Lock_: End
Let w = w And &H3F             'Strip upper bits
Let w = w Or &H40              'Function set
Call LCDPUTCMD
End Sub
Private Sub Display_mode()
'b0    : 0 = cursor blink off, 1 = cursor blink on (if b1 = 1)
'b1    : 0 = cursor off,  1 = cursor on
'b2    : 0 = display off, 1 = display on (display data remains in DD-RAM)
'b3 -b7: don 't care

Let w = Val(cislo)
If w > 255 Then MsgBox "slo nen v rozmez 0 a 255!" & (Chr(13)) & "Mete pout i sla v estnctkov soustav" & (Chr(13)) & "Nap.: 255 = &hff", vbExclamation: Call Lock_: End
Let w = w And &H7             'Strip upper bits
Let w = w Or &H8              'Function set
Call LCDPUTCMD
End Sub
Private Sub Entry_mode()
'b0    : 0 = no display shift, 1 = display shift
'b1    : 0 = auto-decrement, 1 = auto-increment
'b2 -b7: don 't care

Let w = Val(cislo)
If w > 255 Then MsgBox "slo nen v rozmez 0 a 255!" & (Chr(13)) & "Mete pout i sla v estnctkov soustav" & (Chr(13)) & "Nap.: 255 = &hff", vbExclamation: Call Lock_: End
Let w = w And &H3           'Strip upper bits
Let w = w Or &H4            'Function set
Call LCDPUTCMD
End Sub
Private Sub Cursor_home()
Let w = &H2
Call LCDPUTCMD
End Sub
Private Sub write_command()
Let w = Val(cislo)
If w > 255 Then MsgBox "slo nen v rozmez 0 a 255!" & (Chr(13)) & "Mete pout i sla v estnctkov soustav" & (Chr(13)) & "Nap.: 255 = &hff", vbExclamation: Call Lock_: End
Call LCDPUTCMD
End Sub
Private Sub smazat()
Let w = &H1
Call LCDPUTCMD
End Sub
Private Sub text()
Dim a As Long
Dim a1 As String

For a = 1 To Len(Text1)
Let a1 = Mid(Text1, a, 1)
If a1 = " " Then End
Let w = Asc(a1)
Call LCDPUTCHAR
Next a
End Sub
Private Sub About_()
About.Show
End Sub
Private Sub setup1()
Setup.Show
End Sub
Private Sub cr()
Dim a As Long
Dim a1 As String
Dim cas As String * 8
Dim test As Long

Let test = 0
Call Cursor_home
Call smazat

Let w = 67              'C
Call LCDPUTCHAR
Let w = 114             'r
Call LCDPUTCHAR
Let w = 58              ':
Call LCDPUTCHAR

For a = 1 To 4
Let a1 = Mid(credit, a, 1)
Let w = Asc(a1)
Call LCDPUTCHAR
Let test = test + 1
If test >= 5 Then MsgBox "Problm s SW Ovladaem v sexci cr:xxxx!", vbExclamation: Call Lock_: End
Next a
Call mezera

Let test = 0
Let cas = Format(Now, "h:mm AM/PM")

For a = 1 To 8
Let a1 = Mid(cas, a, 1)
Let w = Asc(a1)
Call LCDPUTCHAR
Let test = test + 1
If test >= 9 Then MsgBox "Problm s SW Ovladaem v sexci as!", vbExclamation: Call Lock_: End
Next a
End Sub
Private Sub mezera()
Let w = 32
Call LCDPUTCHAR
End Sub
Private Sub Help1()
Help.Show
End Sub
Private Sub init()

'Let Data = &HCB   '%1100 1011
'Zapis PortAdresa + 2, Data

Call Power_vypnout
Call Cekat1(10000)
Call Power_zapnout


Call Cekat1(10)

Let w = &H30        '8-bit-interface
Call SENDPRIKAZ

Call Cekat1(cas1)

Let w = &H20        '4-bit-interface
Call SENDPRIKAZ

Call Cekat1(cas1)

Let w = &H28        '4-bit-interface, 2-lines
Call LCDPUTCMD
Let w = &H8         'disp.off, curs.off, no-blink
Call LCDPUTCMD
Let w = &H1         'lcd smazat
Call LCDPUTCMD
Let w = &HC         'disp.on, curs.off
Call LCDPUTCMD
Let w = &H6         'Inkrementace, normalni mod.
Call LCDPUTCMD
End Sub

Private Sub Power_zapnout()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() And &HDF      '%1101 1111
Zapis_Control (Data)                     'data zapis

Let Data = Cteni_Control() And &HFB      '%1111 1011
Let Data = Data Or &H4                          '%0000 0100
Zapis_Control (Data)

Let test = 0
power_zap:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci Power zapnout!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H10        '%0001 0000
If w1 = &H10 Then GoTo power_zap
End Sub
Private Sub Power_vypnout()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() Or &H20       '%0010 0000
Zapis_Control (Data)                    'data cist

Let Data = Cteni_Control() And &HFB      '%1111 1011
Zapis_Control (Data)

Let test = 0
power_vyp:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci Power vypnout!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H10        '%0001 0000
If w1 = &H0 Then GoTo power_vyp
End Sub
Private Sub BSF_e()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() And &HFD      '%1111 1101
Let Data = Data Or &H2                          '%0000 0010
Zapis_Control (Data)

Let test = 0
BSF_e_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BSF_e!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H80        '%1000 0000
If w1 = &H80 Then GoTo BSF_e_cekat
End Sub
Private Sub BCF_e()
Dim w1      As Long
Dim test    As Long

Let Data = Cteni_Control() And &HFD      '%1111 1101
Zapis_Control (Data)

Let test = 0
BCF_e_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BCF_e!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H80        '%1000 0000
If w1 = &H0 Then GoTo BCF_e_cekat
End Sub
Private Sub BCF_rs()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() And &HF7      '%1111 0111
Zapis_Control (Data)

Let test = 0
BCF_rs_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BCF_rs!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H20        '%0010 0000
If w1 = &H20 Then GoTo BCF_rs_cekat
End Sub
Private Sub BSF_rs()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() And &HF7      '%1111 0111
Let Data = Data Or &H8                          '%0000 1000
Zapis_Control (Data)

Let test = 0
BSF_rs_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BSF_rs!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H20        '%0010 0000
If w1 = &H0 Then GoTo BSF_rs_cekat
End Sub
Private Sub BSF_rw()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() Or &H20       '%0010 0000
Zapis_Control (Data)                     'data cist

Let Data = Cteni_Control() And &HFE      '%1111 1110
Let Data = Data Or &H1                   '%0000 0001
Zapis_Control (Data)

Let test = 0
BSF_rw_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BSF_rw!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H40        '%0100 0000
If w1 = &H0 Then GoTo BSF_rw_cekat
End Sub
Private Sub BCF_rw()
Dim w1   As Long
Dim test As Long

Let Data = Cteni_Control() And &HDF      '%1101 1111
Zapis_Control (Data)                    'data zapis

Let Data = Cteni_Control() And &HFE      '%1111 1110
Zapis_Control (Data)

Let test = 0
BCF_rw_cekat:
Call Cekat(cas2)
Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci BCF_rw!", vbExclamation: Call Lock_: End
Let w1 = Cteni_Status() And &H40        '%0100 0000
If w1 = &H40 Then GoTo BCF_rw_cekat
End Sub

Private Sub LCDBUSY()
Dim w1   As Long
Dim test As Long

Let test = 0

Call BCF_rs
Call BSF_rw

lcd_busy:
Call BSF_e

Let w1 = Cteni_Data()

Let w1 = w1 And &H80        '%1000 0000
                            'Read busy flag + DDram address
Call BCF_e
Call BSF_e
Call BCF_e

Let test = test + 1
If test >= 255 Then MsgBox "Problm s HW LCD Display v sexci LCD BUSY!", vbExclamation: Call Lock_: End
'If w1 <> &H80 Then GoTo lcd_busy         'Test na BF priznak.
Call BCF_rw
Call BSF_rs

End Sub
Private Sub LCDPUTCMD()

Call SENDPRIKAZ
Call BSF_e

Let w = w * &H10         'spodni nimble je na hornim nimble, a horni nimble se strati!
Let w = w And &HFF       '%1111 1111
                         'swapf LCD_TEMP, f
Call Zapis_w             'Zapise reg. W na PortB.
Call BCF_e
End Sub
Private Sub SENDPRIKAZ()
Call LCDBUSY                'Wait for LCD to be ready

Call BCF_rw
Call BCF_rs
Call BSF_e
Call Zapis_w               'Zapise reg. W na PortB.
Call BCF_e
End Sub
Private Sub LCDPUTCHAR()

Call LCDBUSY            'Wait for LCD to be ready
Call BCF_rw
Call BSF_rs
Call BSF_e
Call Zapis_w            'Zapise reg. W na PortB.
Call BCF_e
Call BSF_e

Let w = w * &H10       'spodni nimble je na hornim nimble, a horni nimble se strati!
Let w = w And &HFF     '%1111 1111
                       'swapf LCD_TEMP, f
Call Zapis_w           'Zapise reg. W na PortB.
Call BCF_e
Call BCF_rs
Call BSF_rw
End Sub
Private Sub Zapis_w()
Let Data = w
Zapis_Data (Data)
Call Cekat(cas2)
End Sub

